﻿//-----------------------------------------------------------------------
//       PA-S500 Win32 API.
//-----------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace Sample
{
    class Pas500w
    {
        //-------------------------------------
        // ｴﾗｰｺｰﾄﾞ定数
        //-------------------------------------
        public const int SUCCESS = 0;               // 異常なし
        public const int ERR_SYSTEM = 1;            // GetLastError を実行してください
        public const int ERR_NO_DEVICE = 2;         // 使用可能なデバイスがない
        public const int ERR_IN_USE = 3;            // 指定されたｽﾛｯﾄは使用中
        public const int ERR_INVALID_SLOT = 4;      // 無効な（論理）ｽﾛｯﾄ番号
        public const int ERR_RESOURCE = 5;          // リソースエラー
        public const int ERR_INVALID_PORT = 6;      // 無効なポート番号
        public const int ERR_INVALID_ARGUMENT = 7;  // 無効な引数
        public const int ERR_NO_CREATE = 8;         // デバイスがクリエイトされていません
        public const int ERR_WRAPDLL = -1;          // ラッパー関数内エラー
        //-------------------------------------
        // Direction
        //-------------------------------------
        public const int DIR_A_OUTPUT = 0x0;
        public const int DIR_A_INPUT = 0x1;
        public const int DIR_B_OUTPUT = 0x0;
        public const int DIR_B_INPUT = 0x2;
        public const int DIR_C_OUTPUT = 0x0;
        public const int DIR_C_INPUT = 0x4;
        public const int DIR_D_OUTPUT = 0x0;
        public const int DIR_D_INPUT = 0x8;
        public const int DIR_E_OUTPUT = 0x0;
        public const int DIR_E_INPUT = 0x10;
        public const int DIR_F_OUTPUT = 0x0;
        public const int DIR_F_INPUT = 0x20;
        //-------------------------------------
        // 論理ﾎﾟｰﾄ
        //-------------------------------------
        public const int PORT_A = 0;
        public const int PORT_B = 1;
        public const int PORT_C = 2;
        public const int PORT_D = 3;
        public const int PORT_E = 4;
        public const int PORT_F = 5;
        //-------------------------------------
        // その他定数
        //-------------------------------------
        public const int MAX_SLOTS = 16;    // サポートするボード枚数
        public const int MAX_PORTS = 6;     // アクセス可能なポート数
        public const short SLOT_AUTO = -1;
        //-------------------------------------
        // ﾘｿｰｽ構造体
        //-------------------------------------
        public const int MAX_MEM = 9;
        public const int MAX_IO = 20;
        public const int MAX_IRQ = 7;
        public const int MAX_DMA = 7;
        public const int MAX_RSV = 3;

        [StructLayout(LayoutKind.Sequential)]
        public struct Resource
        {
            public int dwNumMemWindows; // ﾒﾓﾘｳｲﾝﾄﾞｳ数 未使用
            // ﾒﾓﾘｳｲﾝﾄﾞｳﾍﾞｰｽｱﾄﾞﾚｽ未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_MEM)]
            public int[] dwMemBase;
            // ﾒﾓﾘｳｲﾝﾄﾞｳ長       未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_MEM)]
            public int[] dwMemLength;
            // ﾒﾓﾘｳｲﾝﾄﾞｳ属性     未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_MEM)]
            public int[] dwMemAttrib;
            public int dwNumIOPorts; // I/Oﾎﾟｰﾄ数
            // I/Oﾎﾟｰﾄﾍﾞｰｽｱﾄﾞﾚｽ
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_IO)]
            public int[] dwIOPortBase;
            // I/Oﾎﾟｰﾄ長
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_IO)]
            public int[] dwIOPortLength;
            public int dwNumIRQs; // IRQ数 未使用
            // IRQﾘｽﾄ            未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_IRQ)]
            public int[] dwIRQRegisters;
            // IRQ属性ﾘｽﾄ        未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_IRQ)]
            public int[] dwIRQAttrib;
            public int dwNumDMAs; // DMAﾁｬﾈﾙ数 未使用
            // DMAﾁｬﾈﾙﾘｽﾄ        未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_DMA)]
            public int[] dwDMALst;
            // DMAﾁｬﾈﾙ属性ﾘｽﾄ    未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_DMA)]
            public int[] dwDMAAttrib;
            // 予約              未使用
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = MAX_RSV)]
            public int[] dwReserved1;
        }

        //-------------------------------------
        // 公開関数
        //-------------------------------------
        [DllImport("pas500.dll")]
        public extern static bool Pas500Create(ref short pwLogSlot);
        [DllImport("pas500.dll")]
        public extern static bool Pas500Close(short wLogSlot);
        [DllImport("pas500.dll")]
        public extern static bool Pas500GetResource(short wLogSlot, IntPtr pres);
        [DllImport("pas500.dll")]
        public extern static bool Pas500GetSwitchValue(short wLogSlot, ref int pdwSwitchValue);
        [DllImport("pas500.dll")]
        public extern static bool Pas500GetDirections(short wLogSlot, ref int pdwDirections);
        [DllImport("pas500.dll")]
        public extern static bool Pas500SetDirections(short wLogSlot, int dwDirections);
        [DllImport("pas500.dll")]
        public extern static bool Pas500InPort(short wLogSlot, int dwLogPort, ref byte pbInValue);
        [DllImport("pas500.dll")]
        public extern static bool Pas500OutPort(short wLogSlot, int dwLogPort, byte bOutValue);
        [DllImport("pas500.dll")]
        public extern static int Pas500GetLastError(short wLogSlot);

        //============================================================================
        //  説明   PA-S500の任意のﾃﾞﾊﾞｲｽの使用を宣言
        //  引数   pwLogSlot  使用するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号を格納
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool Create(ref short pwLogSlot)
        {
            try
            {
                return Pas500Create(ref pwLogSlot);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   PA-S500の任意のﾃﾞﾊﾞｲｽの使用を開放
        //  引数   wLogSlot 解放するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool Close(short wLogSlot)
        {
            try
            {
                return Pas500Close(wLogSlot);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   指定ﾃﾞﾊﾞｲｽのﾘｿｰｽ情報を取得
        //  引数   wLogSlot ﾘｿｰｽ情報を取得するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //         pResInfo ﾘｿｰｽ情報を格納する構造体
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool GetResource(short wLogSlot, IntPtr pResInfo)
        {
            try
            {
                return Pas500GetResource(wLogSlot, pResInfo);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   ﾛｰﾀﾘｰｽｲｯﾁの値を取得
        //  引数   wLogSlot       ﾛｰﾀﾘｰｽｲｯﾁの値を取得するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //         pdwSwitchValue ﾛｰﾀﾘｰｽｲｯﾁの値を格納
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool GetSwitchValue(short wLogSlot, ref int pdwSwitchValue)
        {
            try
            {
                return Pas500GetSwitchValue(wLogSlot, ref pdwSwitchValue);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   ﾃﾞｨﾚｸｼｮﾝの状態を取得
        //  引数   wLogSlot      ﾃﾞｨﾚｸｼｮﾝ情報を取得するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //         pdwDirections 状態を格納
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool GetDirections(short wLogSlot, ref int pdwDirections)
        {
            try
            {
                return Pas500GetDirections(wLogSlot, ref pdwDirections);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   ﾃﾞｨﾚｸｼｮﾝをｾｯﾄ
        //  引数   wLogSlot     ﾃﾞｨﾚｸｼｮﾝ情報を設定するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //         dwDirections ｾｯﾄする内容
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool SetDirections(short wLogSlot, int dwDirections)
        {
            try
            {
                return Pas500SetDirections(wLogSlot, dwDirections);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   任意のﾎﾟｰﾄからﾃﾞｰﾀを入力
        //  引数   wLogSlot  入力するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //         dwLogPort 入力する論理ﾎﾟｰﾄ
        //         pbInValue 入力ﾃﾞｰﾀを格納
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool InPort(short wLogSlot, int dwLogPort, ref byte pbInValue)
        {
            try
            {
                return Pas500InPort(wLogSlot, dwLogPort, ref pbInValue);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   任意のﾎﾟｰﾄへﾃﾞｰﾀを出力
        //  引数   wLogSlot  出力するﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //         dwLogPort 出力する論理ﾎﾟｰﾄ
        //         bOutValue 出力するﾃﾞｰﾀ
        //  戻り値 成功 True
        //         失敗 False
        //============================================================================
        public bool OutPort(short wLogSlot, int dwLogPort, byte bOutValue)
        {
            try
            {
                return Pas500OutPort(wLogSlot, dwLogPort, bOutValue);
            }
            catch (Exception)
            {
                return false;
            }
        }
        //============================================================================
        //  説明   PA-S500のｴﾗｰｺｰﾄﾞ
        //  引数   wLogSlot  ｴﾗｰが発生したﾃﾞﾊﾞｲｽの論理ｽﾛｯﾄ番号
        //  戻り値 ｴﾗｰｺｰﾄﾞ
        //============================================================================
        public int GetLastError(short wLogSlot)
        {
            try
            {
                return Pas500GetLastError(wLogSlot);
            }
            catch (Exception)
            {
                return ERR_WRAPDLL;
            }
        }
    }
}
